using System;
using System.Reflection;

public class ClassWithObjectField
{
  private object badField;

  public ClassWithObjectField (int value) {
    badField = value;
  }

  public ClassWithObjectField (Uri value) {
    badField = value;
  }

  public Object SomeValue {
    get {
      return badField;
    }
  }

  public void PrintValue() {
    Console.WriteLine(badField);
  }

  public static void ChangeInt(ref int i) {
    i = i * 2;
  }

  public static void ChangeUri(ref Uri u) {
    u = new Uri("http://www.msn.com");
  }

  public static void Main() {
    ClassWithObjectField intTest = new ClassWithObjectField(123);
    ClassWithObjectField uriTest = new ClassWithObjectField(new Uri("http://www.microsoft.com"));

    Console.WriteLine("Initial values");
    intTest.PrintValue();  // Prints "123"
    uriTest.PrintValue();  // Prints "http://www.microsoft.com"

    object intObject = intTest.SomeValue;
    typeof(ClassWithObjectField).GetMethod("ChangeInt").Invoke(null, new Object[] { intObject });
    object uriObject = uriTest.SomeValue;
    typeof(ClassWithObjectField).GetMethod("ChangeUri").Invoke(null, new Object[] { uriObject });

    Console.WriteLine("After attempt to modify values");
    intTest.PrintValue(); // Prints "246"
    uriTest.PrintValue(); // Prints "http://www.microsoft.com"
  }
}
